//
//  MockScheduleView.swift
//  SMHS Schedule
//
//  Created by Jevon Mao on 4/25/21.
//

import Foundation

extension SharedScheduleInformation {
    static let mockScheduleView = SharedScheduleInformation(placeholderText: sampleText)
    static let sampleText = """
    BEGIN:VCALENDAR\r\nVERSION:2.0\r\nPRODID:-//Santa Margarita Catholic High School/finalsite//NONSGML v1.0//EN\r\nCALSCALE:GREGORIAN\r\nX-WR-CALNAME:BELL Schedule\r\nBEGIN:VEVENT\r\nUID:703702@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210322\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nSpring Recess\\n\\nFaculty/Student Holiday\\n\\nB JV/V Golf @ Ayala Tourn\\n\\nG JV Tennis vs Tesoro 3:00\\n\\nG V Golf vs Aliso Niguel 4:30\\n\\nG V Tennis @ Tesoro 3:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703695@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210323\r\nSUMMARY:Special Schedule Day 5\r\nDESCRIPTION:Period 5                                   8:00-9:05\\n\\nPeriod 6                                   9:12-10:22 \\n(5 minutes for announcements)\\n\\nNutrition             Period 7 \\n10:22-11:02       10:29-11:34 \\n\\nPeriod 7             Nutrition \\n11:09-12:14      11:34-12:14 \\n\\nPeriod 1                                   12:21-1:26 \\n\\nClass Officer Elections            1:31-2:00 \\n(So/Jr report to Distribution Periods for elections) \\n\\nOffice Hours                            2:05-2:30 \\n------------------------------- \\n\\nClass Officer Elections\\n\\n(So/Jr 8:00-2:00)\\n\\n(Fr/Sr 8:00-1:26)\\n\\nHomecoming Spirit Week\\n\\nB FS/JV/V Soccer @ MD 3:15/7:00/5:00\\n\\nFr/V Baseball @ Dana Hills 3:15/3:15\\n\\nG FS/JV/V Soccer vs MD 3:00/7:15/5:30\\n\\nG JV Tennis @ JSerra 3:00\\n\\nG V Tennis vs JSerra 3:15\\n\\nJV Blue Baseball vs Dana Hills 3:15\\n\\nKairos\\n\\nSball @ San Clemente 3:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703692@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210324\r\nSUMMARY:Special Meeting Day 2\r\nDESCRIPTION:Service Fair             8:00-8:55 \\n(Sophomores with last names beginning with A-L have their Service Fair) \\n\\nPeriod 2                   9:00-10:10 \\n(5 minutes for announcements) \\n\\nNutrition                 Period 3 \\n10:10-10:50           10:17-11:22 \\n\\nPeriod 3                  Nutrition \\n10:57-12:02            11:22-12:02 \\n\\nPeriod 4                   12:09-1:14 \\n\\nOffice Hours            1:30-2:30 \\n------------------------------- \\nSophomores A-L Service Fair\\, Pavilion 8:00 \\n(Soph A-L 8:00-1:14) \\n(Fr/Jr/Sr & So M-Z 9:00-1:14) \\nHomecoming Spirit Week\\nB JV Golf @ Hunt Beach 3:00\\nB JV/V LAX @ Yorba Linda 4:00/6:00\\nCheer Tryout Interest Meeting\\, Pavilion 7:00\\nG V LAX vs Tesoro 5:30  \\nJV Sball @ San Clemente 3:30\\nKairos\\nMusical Production Preview\\, B Courtyard 7:30\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703693@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210325\r\nSUMMARY:Regular Day 5\r\nDESCRIPTION:Period 5                   8:00-9:05\\n\\nPeriod 6                   9:12-10:22 \\n(5 minutes for announcements)\\n\\nNutrition              Period 7 \\n10:22-11:02        10:29-11:34 \\n\\nPeriod 7               Nutrition \\n11:09-12:14        11:34-12:14 \\n\\nPeriod 1                   12:21-1:26 \\n\\nOffice Hours            1:33-2:30 \\n------------------------------- \\n\\nHomecoming Spirit Week\\n\\nB FS Golf vs Servite 3:30\\n\\nB JV Golf vs San Juan Hills 4:30\\n\\nJV Gold Baseball @ Trabuco Hills 3:00\\n\\nKairos\\n\\nMusical Production Matinee for Elementary Students\\n\\nMusical Production\\, B Courtyard 7:30\\n\\nV Baseball vs Capo Valley 3:15\\n\\nV Fball vs JSerra 7:00\\n\\nV Sball vs Torrance 5:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703694@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210326\r\nSUMMARY:Special Meeting Day 2\r\nDESCRIPTION:Sophomores M-Z    8:00-8:55 \\n(Service Fair in Gym) \\n\\nPeriod 2                   9:00-10:10 \\n(5 minutes for announcements) \\n\\nNutrition              Period 3 \\n10:10-10:50        10:17-11:22 \\n\\nPeriod 3               Nutrition \\n10:57-12:02        11:22-12:02 \\n\\nPeriod 4                   12:09-1:14 \\n\\nOffice Hours            1:30-2:30 \\n------------------------------- \\n\\nSophomores M-Z Service Fair\\, Pavilion 8:00\\n\\n(Soph M-Z 8:00-1:14)\\n\\n(Fr/Jr/Sr & So A-L 9:00-1:14)\\n\\nHomecoming Spirit Week\\n\\nB FS/JV/V Soccer vs Estancia 3:00/5:00/3:00\\n\\nB V Tennis vs Bosco 3:15\\n\\nCommissioner & Representative Packets Due\\n\\nFr Baseball vs Trabuco Hills 4:00\\n\\nG FS/JV/V Soccer @ Hunt Beach 3:00/4:30/6:00\\n\\nJV Fball @ JSerra 4:00\\n\\nKairos\\n\\nMothers Club Coffee\\n\\nMusical Production\\, B Courtyard 7:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703708@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210327\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:Fr Baseball vs Aliso Niguel 11:00\\nG JV/V LAX vs Los\\nAlamitos 12:00/10:00\\nHomecoming (10/11/12 Gr)\\, 7:00\\nJV Blue Baseball @ Aliso Niguel 11:00\\nJV Gold Baseball @ Laguna Beach 11:00\\nMUN USC (online)\\nMusical Production\\, B Courtyard 7:30\\nSball vs Norco 11:00\\nV Baseball @ Cypress 11:00\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703719@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210328\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:MUN USC (online)\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703690@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210329\r\nSUMMARY:Regular Day 4\r\nDESCRIPTION:Period 4                   8:00-9:05\\n\\nPeriod 5                   9:12-10:22 \\n(5 minutes for announcements)\\n\\nNutrition              Period 6 \\n10:22-11:02        10:29-11:34 \\n\\nPeriod 6              Nutrition \\n11:09-12:14       11:34-12:14 \\n\\nPeriod 7                   12:21-1:26 \\n\\nOffice Hours            1:33-2:30 \\n-------------------------------\\n\\nG V Golf vs Long Beach Wilson 4:30\\n\\nJV Gold Baseball @Villa Park 3:15\\n\\nJV Sball @ Tesoro 3:15\\n\\nSong Team Pre-Audition Workshop\\, Dance Ctr 4:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703689@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210330\r\nSUMMARY:Meeting Day 1\r\nDESCRIPTION:Meeting                   8:00-8:55 \\n\\nPeriod 1                   9:00-10:10 \\n(5 minutes for announcements) \\n\\nNutrition               Period 2 \\n10:10-10:50         10:17-11:22 \\n\\nPeriod 2                Nutrition \\n10:57-12:02         11:22-12:02 \\n\\nPeriod 3                   12:09-1:14 \\n\\nOffice Hours            1:30-2:30 \\n------------------------------- \\n\\nPLC Mtgs 8:00-8:55\\n\\nSr XLT\\, Period 1\\n\\nB FS Golf @ MonarchTourn\\n\\nB FS/JV/V Soccer vsServite 3:00/5:30/7:00\\n\\nFr/JV Blue Baseball @El Toro 3:00/3:00\\n\\nG JV Tennis vs MD 3:15\\n\\nG V LAX @ NewportHarbor 6:30\\n\\nG JV/V Soccer @ Rosary3:00/3:00\\n\\nG V Tennis @ MD 2:30\\n\\nSball vs Tesoro 3:15\\n\\nThespian General Mtg\\,Dome 2:30\\n\\n\\n\\nV Baseball vs El Toro3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703688@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210331\r\nSUMMARY:Regular Day 4\r\nDESCRIPTION:Period 4                   8:00-9:05\\n\\nPeriod 5                   9:12-10:22 \\n(5 minutes for announcements)\\n\\nNutrition                 Period 6 \\n10:22-11:02             10:29-11:34 \\n\\nPeriod 6                  Nutrition \\n11:09-12:14             11:34-12:14 \\n\\nPeriod 7                   12:21-1:26 \\n\\nOffice Hours            1:33-2:30 \\n-------------------------------\\n\\nB FS Golf @ Servite 3:00\\n\\nB JV Tennis @ JSerra 3:15\\n\\nB JV/V Golf Shootout 3:00\\n\\nB JV/V LAX vs Newport Harbor 7:30/5:30\\n\\nB V Tennis vs JSerra 3:15\\n\\nG V Basketball vs San Juan Hills 7:00\\n\\nG V Golf vs Sage Hill 3:00\\n\\nJV Gold Baseball @ Yorba Linda 3:15\\n\\n\\n\\nSball vs Chino Hills 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703685@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210401\r\nSUMMARY:Special Schedule Day 1\r\nDESCRIPTION:Period 1          8:00-9:05\\n\\nPeriod 2          9:12-10:22 \\n(5 minutes for announcements)\\n\\nPeriod 3          10:29-11:34 \\n-------------------------------\\nClasses 8:00-11:34\\n\\nJV Gold Baseball vs Foothill 3:15\\n\\n\\nJV Sball @ Chino 3:15\\n\\n\\n\\nSenior Pilgrimage\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703718@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210402\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:Easter Break \\nFull School Holiday \\nGood Friday\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703684@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210403\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nJV Gold Baseball vs San Juan Hills 11:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703713@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210404\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:Easter Sunday\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703701@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210405\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nEaster Break\\n\\nFull School Holiday\\n\\nFr Baseball vs Los Alamitos 11:00\\n\\nJV Gold Baseball @ Los Alamitos 11:00\\n\\nV Baseball vs Newport Harbor 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703700@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210406\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nEaster Break\\n\\nFaculty/Student Holiday\\n\\nB Fr(B) Basketball vs Bosco 1:00 (@SM)\\n\\nB FS/JV Vball vs Bosco 1:00 (@OL)\\n\\nB JV(A) Basketball vs Bosco 1:00 (@MD)\\n\\nB JV(B) Basketball vs Bosco 1:00 (@JS)\\n\\nFr Baseball vs Notre Dame 11:00\\n\\nJV Blue Baseball @ Notre Dame 11:00\\n\\nJV Gold Baseball @ Yorba Linda 3:15\\n\\nV Baseball vs Yorba Linda 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703687@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210407\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nEaster Break\\n\\nFaculty/Student Holiday\\n\\nB Fr(B) Basketball vs JSerra 9:00 (@SM)\\n\\nB FS/JV Vball vs JSerra 9:00 (@OL)\\n\\nB JV(A) Basketball vs JSerra 9:00 (@MD)\\n\\nB JV(B) Basketball vs JSerra 9:00 (@JS)\\n\\nB V Basketball @ Sage Hill 5:00\\n\\nFr Baseball vs Newport Harbor 3:15\\n\\nJV Gold Baseball @ Kennedy 3:15\\n\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703683@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210408\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nEaster Break\\n\\nFaculty/Student Holiday\\n\\nFr Baseball @ Crean 11:00\\n\\nJV Blue Baseball vs Crean 11:00\\n\\nJV Fball vs MD 4:00\\n\\nJV Gold Baseball @ Tesoro 11:00\\n\\nSball vs Irvine 3:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703682@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210409\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nEaster Break\\n\\nFaculty/Student Holiday\\n\\nB Fr(B) Basketball @ Orange Luth 11:00 (@SM)\\n\\nB FS/JV Vball @ Orange Luth 11:00 (@OL)\\n\\nB JV(A) Basketball @ Orange Luth 11:00 (@MD)\\n\\nB JV(B) Basketball @ Orange Luth 11:00 (@JS)\\n\\nB/G Diving @ Mission Viejo Invitational 10:00\\n\\nFr Baseball vs Tesoro 12:00\\n\\nJV Sball @ Irvine 3:15\\n\\nV Baseball vs Aliso Niguel 3:00\\n\\nV Fball @ MD 7:00\\n\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703686@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210410\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nB Fr(B) Basketball @ MD 11:00 (@SM)\\n\\nB FS/JV Vball @ MD 11:00 (@OL)\\n\\nB JV(A) Basketball @ MD 11:00 (@MD)\\n\\nB JV(B) Basketball @ MD 11:00 (@JS)\\n\\nB V Basketball vs Costa Mesa 4:00\\n\\nB/G Track Eagle Invitational\\, SM Fields 10:00\\n\\nG V LAX @ Foothill 10:00\\n\\n\\nJV Gold Baseball @ Cypress 2:00\\n\\nSM International Rules MUN Conference\\, B Bldg & LunchRm/Patio 9:00\\n\\n\\n\\nV Baseball @ Loara Tourn\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703699@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210411\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nSM International Rules MUN Conference\\, B Bldg & LunchRm/Patio 9:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703680@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210412\r\nSUMMARY:Regular Day 3\r\nDESCRIPTION:Period 3                   8:00-9:05\\n\\nPeriod 4                   9:12-10:22 \\n(5 minutes for announcements) \\n\\nNutrition            Period 5 \\n10:22-11:02      10:29-11:34 \\n\\nPeriod 5            Nutrition \\n11:09-12:14      11:34-12:14 \\n\\nPeriod 6                   12:21-1:26 \\n\\nOffice Hours            1:33-2:30 \\n-------------------------------\\n\\nB FS Golf @ JSerra 3:30\\n\\nCommissioner & Representative Interviews\\n\\n\\nFr Baseball vs Bosco 3:15\\n\\nG JV Golf vs JSerra 4:30\\n\\nG V Golf @ Edison Tourn\\n\\nJV Sball @ Trabuco Hills 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703678@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210413\r\nSUMMARY:Testing Day\r\nDESCRIPTION:\\nB FS/JV/V Soccer @ Bosco 3:15/3:15/3:15\\n\\nB V Basketball vs San Gabriel 6:00\\n\\nB V Vball vs Orange Luth 3:00\\n\\nCommissioner & Representative Interviews\\n\\nCurriculum Council Mtg 2:45\\n\\nFr Baseball @ Lakewood 3:15\\n\\nG FS Soccer @ Davinci 4:30\\n\\nG JV Golf @ JSerra 4:00\\n\\nG JV Tennis @ Rosary 2:30\\n\\nG V Tennis vs Rosary 3:15\\n\\nJV Gold Baseball vs Lakewood 3:15\\n\\nSball vs Trabuco Hills 3:15\\n\\n\\n\\nV Baseball @ Loara Tourn\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703677@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210414\r\nSUMMARY:Meeting Day 7\r\nDESCRIPTION:Meeting                   8:00-8:55 \\n\\nPeriod 7                   9:00-10:10 \\n(5 minutes for announcements) \\n\\nNutrition            Period 1 \\n10:10-10:50      10:17-11:22 \\n\\nPeriod 1            Nutrition \\n10:57-12:02      11:22-12:02 \\n\\nPeriod 2                   12:09-1:14 \\n\\nOffice Hours            1:30-2:30 \\n------------------------------- \\n\\nDept Mtgs 8:00-8:55\\n\\nSpring Signing Day\\, Pavilion 7:30\\n\\nB JV Tennis vs JSerra 3:15\\n\\nB JV/V Vball vs MD 3:00/3:00\\n\\nB V Golf @ St Margaret\'s 3:30\\n\\nB V Tennis @ Orange Luth 2:30\\n\\nCommissioner & Representative Interviews\\n\\nDance Workshop\\, Dance Ctr 3:00\\n\\nFr/JV Gold Baseball @ Dana Hills 3:00/3:00\\n\\nG V Basketball vs Segerstrom 5:30\\n\\n\\n\\nJV Fball @ Servite 3:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703679@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210415\r\nSUMMARY:Special Schedule Day 3\r\nDESCRIPTION:Special Schedule Day 3 \\nThursday\\, April 15\\, 2021 \\n(65 minute classes) \\n\\nPeriod 3                               8:00-10:10 \\n(5 minutes for announcements) \\n(60 minutes for Resurrection Mass 9:10-10:10) \\n\\nNutrition            Period 4 \\n10:10-10:50      10:17-11:22 \\n\\nPeriod 4            Nutrition \\n10:57-12:02      11:22-12:02 \\n\\nPeriod 5                               12:09-1:14 \\n\\nOffice Hours                       1:30-2:30 \\n-------------------------------\\n\\nResurrection Mass\\n\\nClasses 8:00-1:14\\n\\nVolunteer Brunch\\n\\nB FS Golf vs Laguna Beach 3:50\\n\\nB JV Golf vs MD 4:30\\n\\nB/G Swimming vs Bosco 3:15\\n\\nB/G Track vs Tesoro 3:15\\n\\nCommissioner & Representative Interviews\\n\\nFr Baseball @ Bosco 3:15\\n\\nG JV/V LAX @ Canyon 4:00/5:15\\n\\n\\nG V Golf @ Rosary 5:00\\n\\nSball vs Dana Hills 3:30\\n\\nV Baseball @ Loara Tourn\\n\\nV Fball vs Servite 7:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703676@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210416\r\nSUMMARY:Special Schedule Day 6\r\nDESCRIPTION:Special Schedule Day 6 \\nFriday\\, April 16\\, 2021 \\n(55 minute classes/30 minute nutrition breaks) \\n(classes 9:00-1:36) \\n\\nPeriod 6                   9:00-9:55 \\n\\nPeriod 7                  10:02-11:02 \\n(5 minutes for announcements) \\n\\nNutrition              Period 1 \\n11:02-11:32        11:09-12:04 \\n\\nPeriod 1               Nutrition \\n11:39-12:34        12:04-12:34 \\n\\nPeriod 2                   12:41-1:36 \\n\\nOffice Hours                            1:41-2:30 \\n-------------------------------\\nB Fr(B)/JV(A)/V Basketball vs Murrieta Valley 4:00/5:30/7:00 (@SM)\\nB FS/JV/V Soccer @ JSerra 5:15/3:15/3:15\\nB V LAX @ CDM 6:00\\nB V Tennis @ MD 2:45\\nB V Vball @ Servite 3:00\\nB/G JV Swimming vs St Margaret\'s 3:00\\nCheer Tryouts\\, Dance Ctr 3:00\\nCommissioner & Representative Interviews\\nG FS Soccer vs MD 3:00\\nG JV/V Soccer vs JSerra 6:30/5:00\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703675@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210417\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nB Fr(B) Basketball vs Servite 11:00 (@SM)\\n\\nB JV LAX vs El Dorado 10:00\\n\\nB JV Vball vs Servite 11:00 (@OL)\\n\\nB JV(A) Basketball vs Servite 11:00 (@MD)\\n\\nB JV(B) Basketball vs Servite 11:00 (@JS)\\n\\nB V Basketball vs Temecula Valley 5:00\\n\\nB V LAX vs Bosco 12:00\\n\\nFr Baseball vs Bosco 11:00\\n\\nG JV/V LAX @ Edison 12:00/10:00\\n\\nJV Blue Baseball @ Crean 1:00\\n\\nJV Gold Baseball vs MD 2:00\\n\\nSball vs El Segundo 10:00\\n\\n\\n\\nV Baseball @ Loara Tourn\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703673@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210419\r\nSUMMARY:Regular Day 2\r\nDESCRIPTION:Period 2                   8:00-9:05\\n\\nPeriod 3                   9:12-10:22 \\n(5 minutes for announcements) \\n\\nNutrition            Period 4 \\n10:22-11:02      10:29-11:34 \\n\\nPeriod 4            Nutrition \\n11:09-12:14      11:34-12:14 \\n\\nPeriod 5                   12:21-1:26 \\n\\nOffice Hours            1:33-2:30 \\n-------------------------------\\n\\nB Fr Basketball @ San Juan Hills 5:00\\n\\nB JV Tennis @ Servite 2:30\\n\\n\\nB V Tennis vs Servite 3:15\\n\\nEvery 15 Minutes Mock Crash\\n\\nG JV Golf vs Orange Luth 4:30\\n\\nG JV/V LAX vs Orange Luth 7:00/5:30\\n\\nIncoming Frosh Scheduling Night\\, Pavilion/Grotto/Lunch Shelter 6:30\\n\\nV Sball @ Aliso Niguel 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703672@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210420\r\nSUMMARY:Meeting Day 6\r\nDESCRIPTION:Meeting                   8:00-8:55 \\n\\nPeriod 6                   9:00-10:10 \\n(5 minutes for announcements) \\n\\nNutrition            Period 7 \\n10:10-10:50      10:17-11:22 \\n\\nPeriod 7            Nutrition \\n10:57-12:02      11:22-12:02 \\n\\nPeriod 1                   12:09-1:14 \\n\\nOffice Hours            1:30-2:30 \\n------------------------------- \\n\\nPLC Mtgs 8:00-8:55\\n\\nB FS Golf vs Orange Luth 3:30\\n\\nB FS/V Soccer vs Bosco 3:00/5:00\\n\\nB JV/V Golf @ Orange Luth 3:30/3:00\\n\\nFr/JV Blue Baseball @ Mira Costa 3:15/3:15\\n\\nG JV Tennis vs JSerra 3:15\\n\\nG V Basketball vs Aliso Niguel 5:30\\n\\nG V Golf @ MD 2:30\\n\\nG V Tennis @ JSerra 3:15\\n\\nMothers Club Virtual Lunch & Learn 12:00\\n\\nThespian General Mtg\\, Dome 2:45\\n\\n\\nV Baseball vs Mira Costa 3:15\\n\\nV Sball vs Aliso Niguel 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703670@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210421\r\nSUMMARY:Special Virtual Schedule Day 2\r\nDESCRIPTION:Wednesday\\, April 21 \\nSpecial Virtual Day 2 \\n(40 minute classes) \\n\\nPeriod 2                         8:00-8:40 \\n\\nPeriod 3                         8:45-9:25 \\n(10 minute break) \\n\\nPeriod 4                         9:35-10:15 \\n\\nPeriod 5                         10:20-11:40 \\n(40 minute DIVE Presentation) \\n\\nNutrition                      11:40-12:10 \\n\\nPeriod 6                         12:15-12:55 \\n\\nPeriod 7                         1:00-1:40 \\n\\nPeriod 1                         1:45-2:25 \\n-------------------------------\\n\\n\\nClasses 8:00-2:25\\n\\nDive Presentation\\n\\nB JV Tennis vs JSerra 5:30\\n\\nB JV/V LAX vs JSerra 7:30/5:30\\n\\nB JV/V Vball vs Bosco 3:00/3:00\\n\\nB V Basketball vs Bosco 7:00\\n\\nB V Golf @ Hunt Beach 3:00\\n\\nG JV Tennis vs Orange Luth 3:15\\n\\nG V LAX @ JSerra 5:30\\n\\nG V Tennis @ Orange Luth 2:30\\n\\nJV Gold Baseball vs JSerra 3:30\\n\\nJV/V Baseball @ South Hills 2:30/3:15\\n\\n\\n\\nV Sball vs Mission Viejo 3:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703638@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210422\r\nSUMMARY:Regular Day 2\r\nDESCRIPTION:Period 2                   8:00-9:05\\n\\nPeriod 3                   9:12-10:22 \\n(5 minutes for announcements) \\n\\nNutrition             Period 4 \\n10:22-11:02       10:29-11:34 \\n\\nPeriod 4              Nutrition \\n11:09-12:14       11:34-12:14 \\n\\nPeriod 5                   12:21-1:26 \\n\\nOffice Hours            1:33-2:30 \\n-------------------------------\\n\\nB V Golf vs Orange Luth 3:00\\n\\n\\nB/G Swimming vs JSerra 3:15\\n\\nFr Baseball vs JSerra 4:00\\n\\nG JV LAX @ Foothill 7:00\\n\\nG V Golf vs Orange Luth 3:00\\n\\n\\n\\nJV Blue Baseball @ Pacifica 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703668@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210423\r\nSUMMARY:Special Schedule Day 6\r\nDESCRIPTION:Special Schedule Day 6 \\nFriday\\, April 23\\, 2021 \\n(65 minute classes) \\n\\nPeriod 6                               8:00-9:05 \\n\\nPeriod 7                                9:12-10:22 \\n(5 minutes for announcements) \\n\\nNutrition             Period 1 \\n10:22-11:02       10:29-11:34 \\n\\nPeriod 1             Nutrition \\n11:09-12:14       11:34-12:14 \\n\\nRally                                       12:21-1:26 \\n(Seniors go to gym for rally\\, other students stay in period 1 class to watch the rally virtually) \\n\\nOffice Hours                       1:33-2:30 \\n------------------------------- \\n\\nClasses 8:00-1:26\\n\\nB FS Soccer vs MD 3:00\\n\\nB JV LAX @ Orange Luth 4:00\\n\\nB JV/V Soccer vs Orange Luth 6:40/5:00\\n\\nB JV/V Vball vs JSerra 3:00/3:00\\n\\nB V Basketball vs JSerra 7:00\\n\\nIB Ice Cream Social\\, Lunch Shelter 1:30\\n\\nJV Gold Baseball vs JSerra 3:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703669@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210424\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nB Fr(B) Basketball @ Bosco 11:00 (@SM)\\n\\nB JV Tennis @ Orange Luth 12:00\\n\\nB JV Vball @ Bosco 11:00 (@OL)\\n\\nB JV(A) Basketball @ Bosco 11:00 (@MD)\\n\\nB JV(B) Basketball @ Bosco 11:00 (@JS)\\n\\nB JV/V LAX vs Trabuco 10:00/12:00\\n\\nFr Baseball @ JSerra 11:00\\n\\nJV Gold Baseball vs MD 10:00\\n\\nMUN Huntington Beach Novice\\n\\nMUN UCI\\n\\nV Sball vs West Torrance 11:00\\n\\n\\n\\nWinter Formal (Gr 10-12)\\, Marconi Automotive Museum 7:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703671@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210425\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nFball Banquet\\, Pavilion\\n\\nMUN UCI\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703698@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210426\r\nSUMMARY:Special Schedule Day 1\r\nDESCRIPTION:Special Schedule Day 1 \\nMonday\\, April 26\\, 2021 \\n(65 minute classes) \\n\\nPeriod 1                                               8:00-9:05 \\n\\nPeriod 2                                               9:12-10:22 \\n(5 minutes for announcements) \\n\\nNutrition             Period 3 \\n10:22-11:02       10:29-11:34 \\n\\nPeriod 3             Nutrition \\n11:09-12:14       11:34-12:14 \\n\\nPeriod 4                                               12:21-1:26 \\n\\nSpeak UP! Presentation 1:30-2:30 \\n(Performance for Sophomores with last names Adams - Divas report to dome) \\n-------------------------------\\n\\nSpeak Up! Student Presentation\\n\\nB FS Golf @ MD 3:00\\n\\nB V Golf @ JSerra 3:00\\n\\nCommissioner & Representative Interviews\\n\\nIncoming Frosh Scheduling Night\\, Pavilion/Grotto/Lunch Shelter6:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703674@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210427\r\nSUMMARY:Special Meeting Day 5\r\nDESCRIPTION:Special Meeting Schedule Day 5 \\nTuesday\\, April 27\\, 2021 \\n(65 minute classes) \\n\\nPLC Meetings                             8:00-8:55 \\n\\nPeriod 5                                         9:00-10:10 \\n(5 minutes for announcements) \\n\\nNutrition                Period 6 \\n10:10-10:50          10:17-11:22 \\n\\nPeriod 6                 Nutrition \\n10:57-12:02          11:22-12:02 \\n\\nPeriod 7                                          12:09-1:14 \\n\\nSpeak UP! Presentation 1:30-2:30 \\n(Performance for Sophomores with last names Dodd - Li report to dome) \\n-------------------------------\\n\\nPLC Mtgs 8:00-8:55\\n\\nSenior Scholarship Reception\\, Pavilion 8:00\\n\\nSpeak Up! Student Presentation\\n\\nCommissioner & Representative Interviews\\n\\nG JV Tennis @ Orange Luth 2:30\\n\\nG JV/V Golf @ Orange Luth 3:40/2:30\\n\\nG JV/V Soccer @ Orange Luth 5:00/3:15\\n\\nG V Tennis vs Orange Luth 3:15\\n\\nJV Blue Baseball @ Bosco 3:15\\n\\nSong Team Parent Info Mtg\\, SLH 5:30\\n\\nV Baseball vs Bosco 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703691@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210428\r\nSUMMARY:Special Virtual Day 1\r\nDESCRIPTION:Wednesday\\, April 28 \\nSpecial Virtual Day 1 \\n(40 minute classes) \\n\\nPeriod 1                         8:00-8:40 \\n\\nPeriod 2                         8:45-9:25 \\n(10 minute break) \\n\\nPeriod 3                         9:35-10:15 \\n\\nPeriod 4                         10:20-11:40 \\n(40 minute DIVE Presentation) \\n\\nNutrition                      11:40-12:10 \\n\\nPeriod 5                         12:15-12:55 \\n\\nPeriod 6                         1:00-1:40 \\n\\nPeriod 7                         1:45-2:25 \\n-------------------------------\\nClasses 8:00-2:25\\nB JV Tennis vs JSerra 3:15\\nB JV/V LAX @ MD 7:30/5:30\\nB V Basketball @ Orange Luth 7:00\\nB V Tennis @ Bosco 2:00\\nB V Vball @ Orange Luth 3:00\\nCommissioner & Representative Interviews\\nDance Team Info Mtg\\, SLH 5:00\\nDive Presentation\\nG FS Soccer @ Pacifica 3:00\\nG JV/V LAX vs MD 7:00/5:30\\nG V Basketball @ Orange Luth 5:30\\nJV Blue Baseball vs Bosco 3:15\\nSball vs JSerra 3:15\\nSpeak UP! Parent Presentations\\, Dome 5:30/7:00\\nV Baseball @ Bosco 3:15\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703697@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210429\r\nSUMMARY:Special Schedule Day 1\r\nDESCRIPTION:Special Schedule Day 1 \\nThursday\\, April 29\\, 2021 \\n(65 minute classes) \\n\\nPeriod 1                                               8:00-9:05 \\n\\nPeriod 2                                               9:12-10:22 \\n(5 minutes for announcements) \\n\\nNutrition             Period 3 \\n10:22-11:02       10:29-11:34 \\n\\nPeriod 3             Nutrition \\n11:09-12:14      11:34-12:14 \\n\\nPeriod 4                                               12:21-1:26 \\n\\nSpeak UP! Presentation 1:30-2:30 \\n(Performance for Sophomores with last names Liva - Ramirez report to dome) \\n-------------------------------\\n\\nSpeak Up! Student Presentation\\n\\nB FS/JV/V Golf vs JSerra 3:50/4:30/3:00\\n\\nB/G Swimming vs Orange Luth 3:15\\n\\nB/G Track vs JSerra 3:15\\n\\nCabinet Appointments Announced\\n\\nChristian Service Hours Due\\n\\nCommissioner & Representative Interviews\\n\\nFr Baseball vs JSerra 4:00\\n\\nG JV Tennis @ MD 2:45\\n\\nG V Golf vs JSerra 3:00\\n\\nG V Tennis vs MD 3:15\\n\\nSenior Service Hours Due\\n\\nWorld Language Placement Testing\\, 2nd Floor S Bldg 3:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703681@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210430\r\nSUMMARY:Special Meeting Day 5\r\nDESCRIPTION:Special Meeting Schedule Day 5 \\nFriday\\, April 30\\, 2021 \\n(65 minute classes) \\n\\nDept Meetings                             8:00-8:55 \\n\\nPeriod 5                                        9:00-10:10 \\n(5 minutes for announcements) \\n\\nNutrition             Period 6 \\n10:10-10:50       10:17-11:22 \\n\\nPeriod 6             Nutrition \\n10:57-12:02       11:22-12:02 \\n\\nPeriod 7                                          12:09-1:14 \\n\\nSpeak UP! Presentation 1:30-2:30 \\n(Performance for Sophomores with last names Raskulinecz - Yurkovich report to dome) \\n-------------------------------\\n\\nDept Mtgs 8:00-8:55\\n\\nSpeak Up! Student Presentation\\n\\nB FS/JV/V Soccer vs MD 3:00/5:00/7:00\\n\\nB JV Tennis vs JSerra 3:15\\n\\nB V Basketball @ MD 7:00\\n\\nB V Tennis @ JSerra 3:15\\n\\nB V Vball @ MD 3:00\\n\\nG FS/JV/V Soccer @ MD 3:00/6:00/4:30\\n\\nG V Basketball @ MD 5:30\\n\\nJV Blue Baseball @ Bosco 3:15\\n\\nSball @ Orange Luth 3:15\\n\\nSpringSocial (Gr 9)\\, Boomer\'s in Irvine 6:00\\n\\nV Baseball vs Bosco 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703639@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210501\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nB Fr(B) Basketball @ JSerra 3:00 (@JS)\\n\\nB FS/JV Vball @ JSerra 1:00 (@OL)\\n\\n\\nB JV(A) Basketball @ JSerra 1:00 (@MD)\\n\\nB JV(B) Basketball @ JSerra 1:00 (@JS)\\n\\nB JV/V LAX vs Servite 10:00/12:00\\n\\nFr/JV Gold Baseball vs Orange Luth 11:00/2:00\\n\\nG JV LAX @ Orange Luth 11:30\\n\\nG V LAX @ Rosary 10:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703667@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210502\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nMothers Club Fashion Show\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703666@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210503\r\nSUMMARY:Regular Day 7\r\nDESCRIPTION:Period 7                   8:00-9:05 \\n\\nPeriod 1                   9:12-10:22 \\n(5 minutes for announcements) \\n\\nNutrition                 Period 2 \\n10:22-11:02                10:29-11:34 \\n\\nPeriod 2                  Nutrition \\n11:09-12:14                 11:34-12:14 \\n\\nPeriod 3                   12:21-1:26 \\n\\nOffice Hours            1:33-2:30 \\n-------------------------------\\n\\nAP Physics C/Mechanics 12:00\\n\\nAP US Gov\'t & Politics 8:00\\n\\nB FS/JV Golf vs Servite 3:30/4:30\\n\\nB JV/V LAX @ Tesoro 5:30/5:30\\n\\nCurriculum Council Mtg 2:45\\n\\nG JV Tennis vs Rosary 3:15\\n\\nG V Tennis @ Rosary 2:30\\n\\nMUN Awards Banquet\\, Lunch Shelter 6:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703665@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210504\r\nSUMMARY:Meeting Day 4\r\nDESCRIPTION:Meeting        8:00-8:55 \\n\\nPeriod 4        9:00-10:10 \\n(5 minutes for announcements) \\n\\nNutrition                     Period 5 \\n10:10-10:50               10:17-11:22 \\n\\nPeriod 5                     Nutrition \\n10:57-12:02               11:22-12:02 \\n\\nPeriod 6         12:09-1:14 \\n\\nOffice Hours    1:30-2:30 \\n-------------------------------\\n\\nPLC Mtgs 8:00-8:55\\n\\nAP Calculus AB/BC 8:00\\n\\nB FS/JV/V Soccer @ Servite 6:15/4:45/3:15\\n\\nB JV Tennis @ Servite 2:30\\n\\nB V Golf @ MD 2:00\\n\\nB V Tennis vs Orange Luth 3:15\\n\\nB/G Swimming @ MD 3:15\\n\\nCollege Panel Webinar 7:00\\n\\nG FS Soccer vs MD 3:00\\n\\nG JV/V Soccer vs Rosary 6:30/5:00\\n\\nG V Golf @ JSerra 3:30\\n\\nJV Blue Baseball @ JSerra 3:15\\n\\nV Baseball vs JSerra 3:15\\n\\nWorld Lang Placement Testing\\, S Bldg 3:00\\n\\nXLT Night\\, SFS 6:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703664@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210505\r\nSUMMARY:Special Virtual Day 7\r\nDESCRIPTION:Special Virtual Day 7 \\n(40 minute classes) \\n\\nPeriod 7                         8:00-8:40 \\n\\nPeriod 1                         8:45-9:25 \\n(10 minute break) \\n\\nPeriod 2                         9:35-10:15 \\n\\nPeriod 3                         10:20-11:40 \\n(40 minute DIVE Presentation) \\n\\nNutrition                      11:40-12:10 \\n\\nPeriod 4                         12:15-12:55 \\n\\nPeriod 5                         1:00-1:40 \\n\\nPeriod 6                         1:45-2:25 \\n-------------------------------\\n\\nClasses 8:00-2:25\\n\\nDive Presentation\\n\\nAP English Lit & Comp 8:00\\n\\nAP Physics 1/Algebra-Based 12:00\\n\\nB V LAX @ Bosco 5:30\\n\\nB V Vball vs Servite 3:00\\n\\nG JV LAX vs MD 7:00\\n\\nG JV Tennis League Tourn @ SM 11:00\\n\\nG V LAX vs St Margaret\'s 5:30\\n\\nG V Tennis @ League Tourn 11:00\\n\\nJV Blue Baseball vs JSerra 3:15\\n\\nSball @ MD 3:15\\n\\nSpring Dance Concert\\, Dome 7:00\\n\\nV Baseball @ JSerra 6:00\\n\\nV Basketball G vs Rosary/B vs Servite 5:30/7:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703663@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210506\r\nSUMMARY:Special Schedule Day 7\r\nDESCRIPTION:Special Schedule Day 7 \\nThursday\\, May 6\\, 2021 \\n(65 minute classes) \\n\\nPeriod 7                       8:00-10:10 \\n(5 minutes for announcements) \\n(60 minutes for Marian Mass 9:10-10:10) \\n\\nNutrition                Period 1 \\n10:10-10:50          10:17-11:22 \\n\\nPeriod 1                 Nutrition \\n10:57-12:02          11:22-12:02 \\n\\nPeriod 2                       12:09-1:14 \\n\\nOffice Hours                1:30-2:30 \\n-------------------------------\\n\\nMarian Mass\\n\\nClasses 8:00-1:14\\n\\nAP Art History & Computer Sci A 12:00\\n\\nAP US History 8:00\\n\\nB V Golf vs MD 3:00\\n\\nB V Swimming @ Foothill Prelims 3:00\\n\\nB/G Track vs Servite/Rosary 3:15\\n\\nFr Baseball vs Orange Luth 4:00\\n\\nG JV/V Tennis @ League Tourn 9:00\\n\\nG V Golf vs MD 3:00\\n\\nSpring Dance Concert\\, Dome 7:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703662@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210507\r\nSUMMARY:Regular Day 3\r\nDESCRIPTION:Period 3 8:00-9:05\\n\\nPeriod 4 9:12-10:22\\n(5 minutes for announcements)\\n\\nNutrition                      Period 5\\n10:22-11:02                10:29-11:34\\n\\nPeriod 5                        Nutrition\\n11:09-12:14                 11:34-12:14\\n\\nPeriod 6 12:21-1:26\\n\\nOffice Hours 1:33-2:30\\n-------------------------------\\n\\nAP European Hist 12:00\\n\\nB V Basketball @ Bosco 7:00\\n\\nB V Tennis vs MD 3:15\\n\\nB V Vball @ Bosco 3:00\\n\\nB/G Track @ Arcadia Invitational\\n\\nCabaret\\n\\nG V Swimming @ Foothill Prelims 3:00\\n\\nJV Blue Baseball @ JSerra 3:15\\n\\nSball vs Rosary 3:15\\n\\nSenior Class Play\\, Black Box 5:00\\n\\nSpring Dance Concert\\, Dome 7:00\\n\\nV Baseball vs JSerra 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703661@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210508\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nB Fr(B) Basketball vs Orange Luth 9:00 (@SM)\\n\\nB FS/JV Vball vs Orange Luth 9:00 (@OL)\\n\\nB JV(A) Basketball vs Orange Luth 9:00 (@MD)\\n\\nB JV(B) Basketball vs Orange Luth 9:00 (@JS)\\n\\nB JV/V LAX @ St Margaret\'s 10:00/4:00\\n\\nB/G Track @ Arcadia Invitational\\n\\nB/G V Swimming @ Foothill Finals 10:00\\n\\nFr Baseball @ Orange Luth 10:00\\n\\nG JV LAX vs Laguna Beach 12:00\\n\\nG V Basketball vs Cerritos 3:00\\n\\nG V LAX vs JSerra 10:00\\n\\nJV Gold Baseball @ MD 11:00\\n\\nSM Diving Invitational\\, Aquatics Ctr 11:00\\n\\nSpring Dance Concert\\, Dome 7:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703660@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210509\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:Mother\'s Day\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703659@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210510\r\nSUMMARY:Regular Day 6\r\nDESCRIPTION:Period 6 8:00-9:05\\n\\nPeriod 7 9:12-10:22\\n(5 minutes for announcements)\\n\\nNutrition                      Period 1\\n10:22-11:02                10:29-11:34\\n\\nPeriod 1                        Nutrition\\n11:09-12:14                 11:34-12:14\\n\\nPeriod 2 12:21-1:26\\n\\nOffice Hours 1:33-2:30\\n-------------------------------\\n\\nAP French Lang/Culture & Modern World Hist 8:00\\n\\nAP Macroeconomics 12:00\\n\\nB FS Golf vs MD 3:30\\n\\nB JV Golf @ JSerra 3:00\\n\\nB JV Tennis vs Servite 3:15\\n\\nB JV/V LAX @ JSerra 7:00/5:30\\n\\nB V Tennis @ Servite 2:30\\n\\nB V Vball @ JSerra 3:00\\n\\nG JV/V LAX @ Orange Luth 7:00/5:30\\n\\nG V Golf vs Rosary 4:30\\n\\nSenior Graduation Ticket Distribution\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703658@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210511\r\nSUMMARY:Meeting Day 3\r\nDESCRIPTION:Meeting        8:00-8:55\\n\\nPeriod 3        9:00-10:10\\n(5 minutes for announcements)\\n\\nNutrition                     Period 4\\n10:10-10:50               10:17-11:22\\n\\nPeriod 4                     Nutrition\\n10:57-12:02               11:22-12:02\\n\\nPeriod 5         12:09-1:14\\n\\nOffice Hours    1:30-2:30\\n-------------------------------\\n\\nCollegiate Artist Day\\, Dome 8:00\\n\\nPLC Mtgs 8:00-8:55\\n\\nAP Psychology 12:00\\n\\nAP Spanish Lang/Culture 8:00\\n\\nB V Basketball @ JSerra 7:00\\n\\nDance Class Placement Auditions\\, Dance Ctr 3:00\\n\\nG V Basketball @ JSerra 5:30\\n\\nJV Blue Baseball vs Orange Luth 3:15\\n\\nPossible G Tennis CIF\\n\\nV Baseball @ Orange Luth 7:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703657@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210512\r\nSUMMARY:Virtual Day 6\r\nDESCRIPTION:All Students Virtual \\n(45 minute classes) \\n\\nPeriod 6                        8:00-8:45 \\n\\nPeriod 7                        8:50-9:35 \\n(10 minute break) \\n\\nPeriod 1                        9:45-10:30 \\n\\nPeriod 2                        10:35-11:20 \\n\\nNutrition                      11:20-12:00 \\n\\nPeriod 3                        12:05-12:50 \\n\\nPeriod 4                        12:55-1:40 \\n\\nPeriod 5                        1:45-2:30 \\n-------------------------------\\n\\nAP English Lang/Comp 8:00\\n\\nAP Microecon & Music Theory 12:00\\n\\nB JV Tennis League Tourn @ SM 9:00\\n\\nB JV/V LAX vs Orange Luth 7:30/5:30\\n\\nB V Basketball @ JSerra 7:00\\n\\nB V Golf @ Bosco 3:00\\n\\nB V Tennis @ League Tourn 9:00\\n\\nDance Team Auditions\\, Dance Ctr 3:00\\n\\nJV Blue Baseball @ Orange Luth 7:00\\n\\nNick Kraus Concert\\n\\nPossible G Tennis CIF\\n\\nV Baseball vs Orange Luth 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703656@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210513\r\nSUMMARY:Regular Day 6\r\nDESCRIPTION:Period 6 8:00-9:05\\n\\nPeriod 7 9:12-10:22\\n(5 minutes for announcements)\\n\\nNutrition                      Period 1\\n10:22-11:02                10:29-11:34\\n\\nPeriod 1                        Nutrition\\n11:09-12:14                 11:34-12:14\\n\\nPeriod 2 12:21-1:26\\n\\nOffice Hours 1:33-2:30\\n-------------------------------\\n\\nB JV Golf vs Hunt Beach 4:30\\n\\nB JV/V Tennis @ League Tourn 9:00\\n\\nB V Basketball vs Orange Luth 7:00\\n\\nB V Golf @ Servite 2:30\\n\\nB/G Swimming vs Servite/Rosary 3:15\\n\\nB/G Track @ MD 5:00\\n\\nDance Team Auditions\\, Dance Ctr 3:00\\n\\nFr Baseball @ MD 6:15\\n\\nG V Basketball vs Orange Luth 5:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703655@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210514\r\nSUMMARY:Meeting Day 3\r\nDESCRIPTION:Meeting        8:00-8:55\\n\\nPeriod 3        9:00-10:10\\n(5 minutes for announcements)\\n\\nNutrition                     Period 4\\n10:10-10:50               10:17-11:22\\n\\nPeriod 4                     Nutrition\\n10:57-12:02               11:22-12:02\\n\\nPeriod 5         12:09-1:14\\n\\nOffice Hours    1:30-2:30\\n-------------------------------\\n\\nDept Mtgs 8:00-8:55\\n\\nAP Biology 8:00\\n\\nAP Environmental Sci 12:00\\n\\nB V Basketball @ Nike Extravaganza\\n\\nJV Blue Baseball vs Orange Luth 3:15\\n\\nJV Gold Baseball @ Capo Valley 6:30\\n\\nSball @ JSerra 3:15\\n\\nTalon Theatre Banquet\\, Banq Ctr 6:00\\n\\nV Baseball @ Orange Luth 7:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703654@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210515\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nB Fr(B) Basketball vs MD 9:00 (@SM)\\n\\nB FS/JV Vball vs MD 9:00 (@OL)\\n\\nB JV(A) Basketball vs MD 9:00 (@MD)\\n\\nB JV(B) Basketball vs MD 9:00 (@JS)\\n\\nB JV/V LAX vs MD 10:00/12:00\\n\\nFr Baseball vs MD 9:00\\n\\nG JV/V LAX @ MD 12:00/10:00\\n\\nJV Gold Baseball vs Capo Valley 12:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703653@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210516\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nIB Recognition Dinner\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703652@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210517\r\nSUMMARY:Regular Day 5\r\nDESCRIPTION:Period 5 8:00-9:05\\n\\nPeriod 6 9:12-10:22\\n(5 minutes for announcements)\\n\\nNutrition                      Period 7\\n10:22-11:02                10:29-11:34\\n\\nPeriod 7                        Nutrition\\n11:09-12:14                 11:34-12:14\\n\\nPeriod 1 12:21-1:26\\n\\nOffice Hours 1:33-2:30\\n-------------------------------\\n\\n(Fr/So/Jr 8:00-1:26)\\n\\n(Sr 8:00-10:22)\\n\\nSr Semester Assessments Periods 5 & 6\\n\\nAP Statistics 12:00\\n\\nB JV Golf vs Bosco 4:30\\n\\nB V Golf @ League Finals\\n\\nB/G Diving @ League Finals 9:00\\n\\nG JV Golf @ MD 2:30\\n\\nSong Team Audition Clinic\\, Dance Ctr 3:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703651@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210518\r\nSUMMARY:Meeting Day 2\r\nDESCRIPTION:Meeting        8:00-8:55\\n\\nPeriod 2        9:00-10:10\\n(5 minutes for announcements)\\n\\nNutrition                     Period 3\\n10:10-10:50               10:17-11:22\\n\\nPeriod 3                     Nutrition\\n10:57-12:02               11:22-12:02\\n\\nPeriod 4         12:09-1:14\\n\\nOffice Hours    1:30-2:30\\n-------------------------------\\n(Fr/So/Jr 9:00-1:14)\\n(Sr 9:00-11:22/12:02)\\nFac Mtg 8:00-8:55\\nSr Semester Assessments Periods 2 & 3\\nB FS Golf @ Bosco 2:00\\nB V Basketball vs MD 7:00\\nB V Golf @ League Finals\\nG Swimming @ League Prelims 4:00\\nG V Basketball vs MD 5:30\\nG V LAX vs Rosary 5:30\\nJV Blue Baseball vs MD 3:15\\nPossible B Tennis CIF\\nSong Team Audition Clinic\\, Dance Ctr 3:00\\nUnderclassmen Awards\\, Grotto @ Lunch\\nV Baseball @ MD 6:30\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703650@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210519\r\nSUMMARY:Virtual Day 5\r\nDESCRIPTION:All Students Virtual \\n(45 minute classes) \\n\\nPeriod 5                        8:00-8:45 \\n\\nPeriod 6                        8:50-9:35 \\n(10 minute break) \\n\\nPeriod 7                        9:45-10:30 \\n\\nPeriod 1                        10:35-11:20 \\n\\nNutrition                      11:20-12:00 \\n\\nPeriod 2                        12:05-12:50 \\n\\nPeriod 3                        12:55-1:40 \\n\\nPeriod 4                        1:45-2:30 \\n-------------------------------\\n\\nB JV/V LAX @ Servite 7:30/5:30\\n\\nB Swimming @ League Prelims 4:00\\n\\nJV Blue Baseball @ MD 6:15\\n\\nPossible B Tennis CIF\\n\\nSball vs Orange Luth 3:15\\n\\nV Baseball vs MD 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703649@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210520\r\nSUMMARY:Regular Day 5\r\nDESCRIPTION:Period 5 8:00-9:05\\n\\nPeriod 6 9:12-10:22\\n(5 minutes for announcements)\\n\\nNutrition                      Period 7\\n10:22-11:02                10:29-11:34\\n\\nPeriod 7                        Nutrition\\n11:09-12:14                 11:34-12:14\\n\\nPeriod 1 12:21-1:26\\n\\nOffice Hours 1:33-2:30\\n-------------------------------\\n(Fr/So/Jr 8:00-1:26)\\n(Sr 10:29/11:09-1:26)\\nSr Semester Assessments Periods 7 & 1\\nB FS/JV Golf @ Servite 3:00/2:30\\nB V Basketball @ Servite 7:00\\nB V Golf vs Servite 3:00\\nB/G Track vs Orange Luth 3:15\\nCurriculum Council Luncheon\\nFr Baseball @ MD 6:15\\nSong Team Audition\\, Dance Ctr 4:00\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703648@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210521\r\nSUMMARY:Special Schedule Day 2\r\nDESCRIPTION:Special Schedule Day 2 \\nFriday\\, May 21\\, 2021 \\n(65 minute classes) \\n\\nPeriod 2                       8:00-9:05 \\n\\nPeriod 3                       9:12-10:22 \\n(5 minutes for announcements) \\n\\nPeriod 4                       10:29-11:34 \\n-------------------------------\\n\\n(Fr/So/Jr 8:00-11:34)\\n\\n(Sr 10:29-11:34)\\n\\nSr Semester Assessments Period 4\\n\\nB Fr(B)/JV(A)/JV(B) Basketball @ MD 2:30/5:30/4:00 (@MD)\\n\\nB/G Swimming @ League Finals 2:00\\n\\nG V Basketball @ Rosary 5:30\\n\\nJV Blue Baseball vs MD 3:15\\n\\nSball vs MD 3:15\\n\\nV Baseball @ MD 6:30\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703647@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210522\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nB Fr(B) Basketball @ Servite 9:00 (@SM)\\n\\nB FS/JV Vball @ Servite 9:00 (@OL)\\n\\nB JV(A) Basketball @ Servite 9:00 (@MD)\\n\\nB JV(B) Basketball @ Servite 9:00 (@JS)\\n\\nB JV/V LAX vs Beckman 10:00/12:00\\n\\nB V Basketball vs Burbank 3:00\\n\\nFr Baseball vs Servite 9:00\\n\\nJV Gold Baseball vs Orange Luth 12:00\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703646@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210524\r\nSUMMARY:Special Schedule\r\nDESCRIPTION:\\n Monday\\,May 24\\, 2021:   Semester Assessments -Periods 4 & 5   \\n\\n·         Period 4 Assessments  8:00-9:35 (5 minutes added for announcements)  \\n\\n·         Period 5 Assessments  9:55-11:25   \\n\\n-------------------------------\\n\\n(Fr/So/Jr 8:00-11:25)\\n\\nFr/So/Jr Semester Assessments Periods 4 & 5\\n\\nG V Golf @ League Tourn\\n\\nJV Blue Baseball @ Servite 3:15\\n\\nSenior Awards\\n\\nSenior Cap and Gown Distribution\\n\\nSenior Graduation Practice\\n\\n\\n\\nV Baseball vs Servite 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703645@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210525\r\nSUMMARY:Special Schedule\r\nDESCRIPTION:\\n Tuesday\\,May 25\\, 2021:   Semester Assessments -Periods 6 & 7   \\n\\n·         Period 6 Assessments  8:00-9:35 (5 minutes added for announcements)  \\n\\n·         Period 7 Assessments  9:55-11:25  \\n\\n-------------------------------\\n\\n(Fr/So/Jr 8:00-11:25)\\n\\nFr/So/Jr Semester Assessments Periods 6 & 7\\n\\nB FS Golf vs JSerra 3:30\\n\\nB JV Golf @ Bosco 3:00\\n\\nG V Golf @ League Tourn\\n\\nJV Blue Baseball vs Servite 3:15\\n\\nPossible B/G Diving CIF\\n\\nProm - 11th Grade\\n\\nSenior Cruise\\n\\n\\n\\nV Baseball @ Servite 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703644@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210526\r\nSUMMARY:Special Schedule\r\nDESCRIPTION:\\n Wednesday\\,May 26\\, 2021:   Semester Assessments -Periods 1 & 2   \\n\\n·         Period 1 Assessments  8:00-9:35 (5 minutes added for announcements)  \\n\\n·         Period 2 Assessments  9:55-11:25  \\n\\n-------------------------------\\n\\n(Fr/So/Jr 8:00-11:25)\\n\\nFr/So/Jr Semester Assessments Periods 1& 2\\n\\nFaculty/Staff Year End Luncheon\\, Coto Valley CC 12:15\\n\\nB JV Golf @ MD 2:30\\n\\nB V Golf vs Bosco 3:00\\n\\nB/G Track League Prelims\\, SM Fields 2:00\\n\\nFr Baseball @ Servite 3:15\\n\\nProm - 12th Grade\\n\\n\\n\\nSball @ Rosary 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703643@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210527\r\nSUMMARY:Special Schedule\r\nDESCRIPTION:\\n Thursday\\,May 27\\, 2021:   Semester Assessments -Period 3   \\n\\n·         Period 3 Assessments  8:00-9:35 (5 minutes added for announcements)  \\n\\n-------------------------------\\n\\n(Fr/So/Jr 8:00-9:35)\\n\\nBaccalaureate Mass\\n\\nFr/So/Jr Semester Assessments Period 3\\n\\nB FS Golf vs Bosco 3:30\\n\\nJV Blue Baseball @ Servite 3:15\\n\\n\\n\\nPossible B/G Swimming CIF\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703642@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210528\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nGraduation\\n\\nGrad Night\\n\\nB/G Track League Finals\\, SM Fields 3:30\\n\\nFr Baseball vs Servite 3:15\\n\\nV Baseball vs Servite 3:15\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703641@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210529\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nB/G Track Awards Picnic\\, SM Track 12:00\\n\\nPossible B/G Diving CIF\\n\\nPossible B/G Swimming CIF\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\nBEGIN:VEVENT\r\nUID:703640@smhsorg.finalsite.com\r\nDTSTAMP:20210421T222201Z\r\nDTSTART;VALUE=DATE:20210531\r\nSUMMARY:SMCHS Events\r\nDESCRIPTION:\\nMemorial Day\\n\\nFull School Holiday\\n\\nPossible B Golf CIF\\n\r\nPRIORITY:0\r\nEND:VEVENT\r\n\r\nEND:VCALENDAR\r\n

    """
}


